import React, { Component } from "react";
import axios from 'axios'
import { message ,Spin } from "antd";
// import EmployeeForm from "./EmployeeForm";

import RecordSelector from "wp-record-selector";

class Employee extends Component {
  columns = [
  {
    title: "Id",
    dataIndex: "id",
    key: "id",
    width: '10%'
  },
  {
    title: "Name",
    dataIndex: "employee_name",
    key: "employee_name",
    width: '55%'
  },
  {
    title: "Salary",
    dataIndex: "employee_salary",
    key: "employee_salary",
    width: '25%'
  },
  {
    title: "Age",
    dataIndex: "employee_age",
    key: "employee_age",
    width: '10%'
  }];

  state = {
    employee: {},
    employees: [],
    formMessage: "",
    selectorMessage: "",
    spinMessage: null,
  };

  componentWillMount() {
    this.loadEmployees();
  }

  fetchEmployees = () => {
    const request = axios.get(`http://http://dummy.restapiexample.com/api/v1/employees`)
    return request
  }

 loadEmployees = () => {
  this.setState({ spinMessage: "Loading Employees..." });
  this.fetchEmployees()
   .then((res) => {
    let employees = res.data;
    this.setState({
     employees,
     spinMessage: null,
    });
   })
   .catch((err) => {
    message.error(`Error loading Employees: ${err}`);
    console.error("Error loading Employees:", err);
    this.setState({ spinMessage: null });
   });
 };

  handleSelectRecord = (record) => {
    console.log("handleSelectRecord", record)
    const {employees, employee} = this.state
    const person = employees.find(p => p.id === record.id)
    this.setState({
      employee: person,
      undo: employee,
      spinMessage: null,
    })
  };

 handleNewRecord = () => {
  this.setState({ employee: {} });
 };

 handleUndoRecord = () => {
  this.setState({
   employee: this.state.undo,
  });
 };

 render() {
  return (
   <Spin
    tip={this.state.spinMessage}
    spinning={this.state.spinMessage ? true : false}
   >
    {/* <Container
     leftSpan="10"
     sider={() => (
      <React.Fragment> */}
       <RecordSelector
        dataSource={this.state.employees}
        columns={this.columns}
        onSelect={this.handleSelectRecord}
        message={this.state.selectorMessage}
       />
      {/* </React.Fragment> 
     )}
    > */}
     {/* <EmployeeForm
      employee={this.state.employee}
      onNew={this.handleNewRecord}
      onUndo={this.handleUndoRecord}
      onDelete={this.handleDeleteRecord}
      onSave={this.handleSaveRecord}
      message={this.state.formMessage}
     />
    </Container> */}
   </Spin>
  );
 }
}

export default Employee;
